package net.mcreator.you_wont_understand;

import net.minecraftforge.fml.relauncher.SideOnly;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.common.registry.GameRegistry;
import net.minecraftforge.fml.common.registry.EntityEntry;
import net.minecraftforge.fml.common.network.NetworkRegistry;
import net.minecraftforge.fml.common.network.IGuiHandler;
import net.minecraftforge.fml.common.eventhandler.SubscribeEvent;
import net.minecraftforge.fml.common.event.FMLServerStartingEvent;
import net.minecraftforge.fml.common.event.FMLPreInitializationEvent;
import net.minecraftforge.fml.common.event.FMLInitializationEvent;
import net.minecraftforge.fml.common.SidedProxy;
import net.minecraftforge.fml.common.Mod.Instance;
import net.minecraftforge.fml.common.Mod.EventHandler;
import net.minecraftforge.fml.common.Mod;
import net.minecraftforge.fml.common.IWorldGenerator;
import net.minecraftforge.fml.common.IFuelHandler;
import net.minecraftforge.fluids.FluidRegistry;
import net.minecraftforge.event.RegistryEvent;
import net.minecraftforge.common.MinecraftForge;
import net.minecraftforge.client.event.ModelRegistryEvent;

import net.minecraft.world.gen.IChunkGenerator;
import net.minecraft.world.chunk.IChunkProvider;
import net.minecraft.world.biome.Biome;
import net.minecraft.world.World;
import net.minecraft.potion.Potion;
import net.minecraft.item.ItemStack;
import net.minecraft.item.Item;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.block.Block;

import java.util.function.Supplier;
import java.util.Random;
import java.util.List;
import java.util.ArrayList;

@Mod(modid = you_wont_understand.MODID, version = you_wont_understand.VERSION)
public class you_wont_understand implements IFuelHandler, IWorldGenerator {

	public static final String MODID = "you_wont_understand";
	public static final String VERSION = "1.0.0";
	@SidedProxy(clientSide = "net.mcreator.you_wont_understand.ClientProxyyou_wont_understand", serverSide = "net.mcreator.you_wont_understand.CommonProxyyou_wont_understand")
	public static CommonProxyyou_wont_understand proxy;
	@Instance(MODID)
	public static you_wont_understand instance;
	public final List<ModElement> elements = new ArrayList<>();
	public final List<Supplier<Block>> blocks = new ArrayList<>();
	public final List<Supplier<Item>> items = new ArrayList<>();
	public final List<Supplier<Biome>> biomes = new ArrayList<>();
	public final List<Supplier<EntityEntry>> entities = new ArrayList<>();
	public final List<Supplier<Potion>> potions = new ArrayList<>();

	public you_wont_understand() {
		FluidRegistry.enableUniversalBucket();
		elements.add(new MCreatorRouletteRusse(this));
		elements.add(new MCreatorRandomKill(this));
		elements.add(new MCreatorYouWontUnderstand(this));
		elements.add(new MCreatorShinyPotatoe(this));
		elements.add(new MCreatorGettingBedrock(this));
		elements.add(new MCreatorUpsideDownDiamond(this));
		elements.add(new MCreatorTheChooser(this));
		elements.add(new MCreatorChoosing(this));
		elements.add(new MCreatorOres(this));
		elements.add(new MCreatorOresRecipe(this));
		elements.add(new MCreatorShinyPotatoeRecipe(this));
		elements.add(new MCreatorTheChooserRecipe(this));
		elements.add(new MCreatorShinyDestroyer(this));
		elements.add(new MCreatorShinyDestroyerRecipe(this));
		elements.add(new MCreatorDestroying(this));
		elements.add(new MCreatorIridiumOre(this));
		elements.add(new MCreatorJuice(this));
		elements.add(new MCreatorIntoxication(this));
		elements.add(new MCreatorJuicyShinyPotatoe(this));
		elements.add(new MCreatorGreenPotatoeRecipe(this));
		elements.add(new MCreatorTheArmor(this));
		elements.add(new MCreatorHelmetRecipe(this));
		elements.add(new MCreatorTShirtRecipe(this));
		elements.add(new MCreatorPantsRecipe(this));
		elements.add(new MCreatorBootsRecipe(this));
		elements.add(new MCreatorHelmet(this));
		elements.add(new MCreatorChestplate(this));
		elements.add(new MCreatorLeggings(this));
		elements.add(new MCreatorBoots(this));
		elements.add(new MCreatorOneminuteeffects(this));
		elements.add(new MCreatorJuiceBucket(this));
		elements.add(new MCreatorJuiceBucketRecipe(this));
		elements.add(new MCreatorFrame(this));
		elements.add(new MCreatorFilledFrame(this));
		elements.add(new MCreatorFilling(this));
		elements.add(new MCreatorTaking(this));
		elements.add(new MCreatorUpsidedowndiamondblock(this));
		elements.add(new MCreatorOne(this));
		elements.add(new MCreatorTwo(this));
		elements.add(new MCreatorUniversalMiner(this));
		elements.add(new MCreatorUniversalrecipe(this));
		elements.add(new MCreatorExtracting(this));
	}

	@Override
	public int getBurnTime(ItemStack fuel) {
		for (ModElement element : elements) {
			int ret = element.addFuel(fuel);
			if (ret != 0)
				return ret;
		}
		return 0;
	}

	@Override
	public void generate(Random random, int chunkX, int chunkZ, World world, IChunkGenerator cg, IChunkProvider cp) {
		elements.forEach(element -> element.generateWorld(random, chunkX * 16, chunkZ * 16, world, world.provider.getDimension(), cg, cp));
	}

	@SubscribeEvent
	public void registerBlocks(RegistryEvent.Register<Block> event) {
		event.getRegistry().registerAll(blocks.stream().map(Supplier::get).toArray(Block[]::new));
	}

	@SubscribeEvent
	public void registerItems(RegistryEvent.Register<Item> event) {
		event.getRegistry().registerAll(items.stream().map(Supplier::get).toArray(Item[]::new));
	}

	@SubscribeEvent
	public void registerBiomes(RegistryEvent.Register<Biome> event) {
		event.getRegistry().registerAll(biomes.stream().map(Supplier::get).toArray(Biome[]::new));
	}

	@SubscribeEvent
	public void registerEntities(RegistryEvent.Register<EntityEntry> event) {
		event.getRegistry().registerAll(entities.stream().map(Supplier::get).toArray(EntityEntry[]::new));
	}

	@SubscribeEvent
	public void registerPotions(RegistryEvent.Register<Potion> event) {
		event.getRegistry().registerAll(potions.stream().map(Supplier::get).toArray(Potion[]::new));
	}

	@SubscribeEvent
	public void registerSounds(RegistryEvent.Register<net.minecraft.util.SoundEvent> event) {
	}

	@SubscribeEvent
	@SideOnly(Side.CLIENT)
	public void registerModels(ModelRegistryEvent event) {
		elements.forEach(element -> element.registerModels(event));
	}

	@EventHandler
	public void preInit(FMLPreInitializationEvent event) {
		MinecraftForge.EVENT_BUS.register(this);
		GameRegistry.registerFuelHandler(this);
		GameRegistry.registerWorldGenerator(this, 5);
		NetworkRegistry.INSTANCE.registerGuiHandler(this, new GuiHandler());
		elements.forEach(element -> element.preInit(event));
		proxy.preInit(event);
	}

	@EventHandler
	public void init(FMLInitializationEvent event) {
		elements.forEach(element -> element.init(event));
		proxy.init(event);
	}

	@EventHandler
	public void serverLoad(FMLServerStartingEvent event) {
		elements.forEach(element -> element.serverLoad(event));
	}

	public static class GuiHandler implements IGuiHandler {

		@Override
		public Object getServerGuiElement(int id, EntityPlayer player, World world, int x, int y, int z) {
			return null;
		}

		@Override
		public Object getClientGuiElement(int id, EntityPlayer player, World world, int x, int y, int z) {
			return null;
		}
	}

	public static class ModElement {

		public static you_wont_understand instance;

		public ModElement(you_wont_understand instance) {
			this.instance = instance;
		}

		public void init(FMLInitializationEvent event) {
		}

		public void preInit(FMLPreInitializationEvent event) {
		}

		public void generateWorld(Random random, int posX, int posZ, World world, int dimID, IChunkGenerator cg, IChunkProvider cp) {
		}

		public void serverLoad(FMLServerStartingEvent event) {
		}

		public void registerModels(ModelRegistryEvent event) {
		}

		public int addFuel(ItemStack fuel) {
			return 0;
		}
	}
}
